package practicas;

import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.IOException;

/**
 * Clase: Practica1
 * Descripcin: Esta clase representa la solucin a la prctica 1 de Programacin
 * Creada por: Manuel Pereira
 * Fecha: 13-feb-2007
 */

public class Practica1 {

    /**
     * Mtodo principal
     * @param args Argumentos recibidos por lnea de comandos
     */
    public static void main(String[] args) {

        // Crea el tablero
	Tablero t = new Tablero();

        while(!t.juegoGanado()) {
            System.out.println(t.toString());

            // Pide al usuario por pantalla el movimiento
            InputStreamReader isr = new InputStreamReader(System.in);
            BufferedReader br = new BufferedReader(isr);
            System.out.print("Introduce el movimiento (W/S/A/D - q para salir): ");

            String teclaPulsada = null;
            try {
                teclaPulsada = br.readLine();
            } catch(IOException ioe) {
                System.out.println("Excepcin al leer de teclado");
                System.exit(-1);
            }

            t.siguienteMovimiento(teclaPulsada);

            if(t.juegoPerdido()) {
                if(t.getVidas() == 0) {
                    System.out.println("\nHas perdido!\n");
                    System.exit(-1);
                }
                else {
                    System.out.println("\nHas perdido una vida!\n");
                    t.pierdeVida();
                }
            }
        }
        System.out.println("Has ganado!");
        System.exit(0);
    }
}

