package practicas;

/**
 * Clase: ListaMovimientos
 * Descripcin: Esta clase representa una lista de movimientos
 * Creada por: Daniel Prez
 * Fecha: 10-may-2007
 */

public class ListaMovimientos{

	    /** Variable para la lista de movimientos */
	    private Movimiento[] lista;
	    
	    /**
	     * Constructor de una lista de movimientos. 
	     */
	    public ListaMovimientos() {
	        lista = null;
	    }
	    
	    /**
	     * Constructor de una lista de movimientos. 
	     */
	    public ListaMovimientos(Movimiento[] m) {
	        lista = m;
	    }
	    
	    /**
	     * Constructor de una lista de movimientos. 
	     */
	    public boolean esVacia() {
	        return lista == null;
	    }

	    public int getLongitud(){
	        return lista.length;
	    }
	        
	    public Movimiento getMovimiento(int pos){
	        return lista[pos];
	    }

	    /**
	     * Mtodo de ordenacin burbuja
	     * @param ultimo ltimo ndice de la lista a ordenar
	     */
	    public void ordenar (int ultimo){
	        Movimiento aux;
	        boolean cambio = true;

	        for (int i=1; i<=ultimo && cambio; i++){
	            cambio = false;
	            for (int j=0; j<=ultimo-i; j++){
	                if (!lista[j].menor(lista[j+1])){
	                    cambio = true;
	                    aux = lista [j+1];
	                    lista [j+1] = lista [j];
	                    lista [j] = aux;
	                }
	            }
	        }
	    }
	    public void mostrar(){
	        System.out.println("LISTA DE MOVIMIENTOS");
	        System.out.println("--------------------");
	        for (int i=0; i<lista.length; i++){
	            lista[i].mostrar();
	        }
	        System.out.println();
	    }
}

