package practicas;

import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.IOException;

/**
 * Clase: Practica2
 * Descripcin: Esta clase representa la solucin a la prctica 2 de Programacin
 * Creada por: Daniel Prez
 * Fecha: 10-may-2007
 */

public class Practica2 {

    /**
     * Mtodo principal
     * @param args Argumentos recibidos por lnea de comandos
     */
    public static void main(String[] args) {
     
        
        int roj = Enemigo.COLOR_ROJO;
        int azu = Enemigo.COLOR_AZUL;
        int nar = Enemigo.COLOR_NARANJA;
        int ros = Enemigo.COLOR_ROSA;
        
        
        // Crea los enemigos (son asignados a casillas de tipo Guarida)
        Enemigo[] e = new Enemigo[4];
        e[0] = new Enemigo(12, 12, Individuo.DIRECCION_ARRIBA, "Reud", roj);
        e[1] = new Enemigo(13, 12, Individuo.DIRECCION_ARRIBA, "Loki", azu);
        e[2] = new Enemigo(14, 12, Individuo.DIRECCION_ARRIBA, "Scio", nar);
        e[3] = new Enemigo(15, 12, Individuo.DIRECCION_ARRIBA, "Niel", ros);
        
        Lista enemigos = new Lista(e);
        
        // Crea el protagonista
        Protagonista prota = new Protagonista(13, 21, Individuo.DIRECCION_IZQUIERDA);

        // Crea el tablero
        Tablero t = new Tablero(enemigos, prota);

        boolean cont=true;
        while(true){
        	//Para utilizar varias pantallas
        	if (cont){
        		t.crearTableroInicial();
        		cont=!cont;
        	}else {
        		t.crearTableroSecundario();
        		t.nuevaVida();
        	}
        	
//        	 Mientras la pantalla no haya sido completado
            while(!t.juegoGanado()) {
                System.out.println(t.mostrarTablero());

                // Pide al usuario por pantalla el movimiento
                InputStreamReader isr = new InputStreamReader(System.in);
                BufferedReader br = new BufferedReader(isr);
                System.out.print("Introduce el movimiento (W/S/A/D - q para salir): ");

                // Se lee la tecla pulsada
                String teclaPulsada = null;
                try {
                    teclaPulsada = br.readLine();
                } catch(IOException ioe) {
                    System.out.println("Excepcin al leer de teclado");
                    System.exit(-1);
                }
                
                // Se completa el siguiente movimiento de protagonista y enemigos
                t.siguienteMovimiento(teclaPulsada);
            }
//          El juego finaliza con victoria del jugador
            System.out.println("Has terminado la pantalla.!");
        }
        
        
    }
}
