package practicas;

import java.awt.*;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

/**
 * User: Manuel Pereira
 * Date: 05-may-2006
 * Time: 16:46:01
 * Clase que se encarga de pintar el tablero del comecocos
 * Esta clase NO deberá ser modificada por el alumno para realizar la práctica 3
 */
public class ComecocosPractica3 extends Frame {

    private static final int PIXELSCUADRADO = 15;
    private static final int PIXELSPUNTO = 2;
    private static final int BORDE = 25;
    private static final int ANCHODERECHA = (PIXELSCUADRADO + 1) * 5;
    private int altoFrame;
    private int anchoFrame;
    private int alto;
    private int ancho;
    public int[][] tablero;
    public int puntos;
    private Tablero tableroFisico;


    private static final int COLOR_ROJO = -65536;
    private static final int COLOR_VERDE = -16711936;
    private static final int COLOR_AZUL = -16776961;
    private static final int COLOR_NARANJA = -14336;
    private static final int COLOR_AMARILLO = -256;
    private static final int COLOR_CYAN = -16711681;
    private static final int COLOR_NEGRO = -16777216;
    private static final int COLOR_BLANCO = -1;


    public ComecocosPractica3(int ancho, int alto, int intervalo)
    {	    
        this.ancho = ancho;
        this.alto = alto;
        tablero = new int[alto][ancho];
        anchoFrame = ancho * (PIXELSCUADRADO+1) + (2 * BORDE) + ANCHODERECHA;
        altoFrame = alto * (PIXELSCUADRADO+1) + (2 * BORDE);
        setSize (anchoFrame, altoFrame);
        setTitle("Comecomos Practica 3");
        RellenarPorAlumno.comecocos = this;
        RellenarPorAlumno.intervalo = intervalo;
        RellenarPorAlumno rpa = new RellenarPorAlumno();
        tableroFisico = rpa.getTablero();
        addKeyListener (new TeclaPulsada(rpa));
        rpa.start();
   }

    public void update (Graphics g)
    {
        Image buffer = createImage (anchoFrame, altoFrame);
        Graphics sg = buffer.getGraphics();
        sg.clearRect(0, 0, anchoFrame, altoFrame);
        pintarTablero(sg);
        g.drawImage (buffer, 0, 0, this);
    }

    /**
     * Pinta el tablero del comecocos
     * @param g Graphics en el que pintarlo
     */
    public void pintarTablero(Graphics g)
    {

        // Pinta los bordes
        g.fillRect(BORDE - 2, BORDE - 2, (PIXELSCUADRADO+1)* (ancho) + 3, (PIXELSCUADRADO+1) * (alto) + 3);
        /*
        g.fillRect(BORDE + (PIXELSCUADRADO+1)* (ancho +1) - 2,
                   BORDE + (PIXELSCUADRADO+1) - 2,
                   (PIXELSCUADRADO+1)* (DIMENSIONPIEZA) + 3, (PIXELSCUADRADO+1) * (DIMENSIONPIEZA) + 3);
*/                   

        // Pinta el tablero
        for (int i = 0; i < alto; i++) {
            for (int j = 0; j < ancho; j++) {
                int tipoCasilla = tablero[i][j];
                switch(tipoCasilla) {
                    // Pinta la casilla vacía
                    case Temporizador.ICONO_VACIA:
                        g.setColor(new Color(COLOR_NEGRO));
                        g.fillRect(BORDE+(PIXELSCUADRADO+1)*j, BORDE+(PIXELSCUADRADO+1)*i, PIXELSCUADRADO, PIXELSCUADRADO);
                        break;
                    // Pinta un muro
                    case Temporizador.ICONO_MURO:
                        g.setColor(new Color(COLOR_NARANJA));
                        g.fillRect(BORDE+(PIXELSCUADRADO+1)*j, BORDE+(PIXELSCUADRADO+1)*i, PIXELSCUADRADO, PIXELSCUADRADO);
                        break;
                    case Temporizador.ICONO_GUARIDA:
                        g.setColor(new Color(COLOR_VERDE));
                        g.fillRect(BORDE+(PIXELSCUADRADO+1)*j, BORDE+(PIXELSCUADRADO+1)*i, PIXELSCUADRADO, PIXELSCUADRADO);
                        break;                
                    // Pinta un punto
                    case Temporizador.ICONO_PUNTO:
                        g.setColor(new Color(COLOR_BLANCO));
                        g.fillRect(BORDE+(PIXELSCUADRADO+1)*j+((PIXELSCUADRADO-PIXELSPUNTO)/2), BORDE+(PIXELSCUADRADO+1)*i+((PIXELSCUADRADO-PIXELSPUNTO)/2), PIXELSPUNTO, PIXELSPUNTO);
                        break;                        
                    case Temporizador.ICONO_FRUTA:
                        g.setColor(new Color(COLOR_ROJO));
                        g.fillRect(BORDE+(PIXELSCUADRADO+1)*j+((PIXELSCUADRADO-PIXELSPUNTO)/2), BORDE+(PIXELSCUADRADO+1)*i+((PIXELSCUADRADO-PIXELSPUNTO)/2), 5*PIXELSPUNTO, 5*PIXELSPUNTO);
                        break;
                    case Temporizador.ICONO_PROTAGONISTA_ARRIBA:
                        g.setColor(new Color(COLOR_AMARILLO));
                        g.fillArc(BORDE+(PIXELSCUADRADO+1)*j, BORDE+(PIXELSCUADRADO+1)*i, PIXELSCUADRADO-2, PIXELSCUADRADO-2, 120, 300);
                        break;
                    case Temporizador.ICONO_PROTAGONISTA_ABAJO:
                        g.setColor(new Color(COLOR_AMARILLO));
                        g.fillArc(BORDE+(PIXELSCUADRADO+1)*j, BORDE+(PIXELSCUADRADO+1)*i, PIXELSCUADRADO-2, PIXELSCUADRADO-2, 300, 300);
                        break;
                    case Temporizador.ICONO_PROTAGONISTA_IZQUIERDA:
                        g.setColor(new Color(COLOR_AMARILLO));
                        g.fillArc(BORDE+(PIXELSCUADRADO+1)*j, BORDE+(PIXELSCUADRADO+1)*i, PIXELSCUADRADO-2, PIXELSCUADRADO-2, 210, 300);
                        break;
                    case Temporizador.ICONO_PROTAGONISTA_DERECHA:
                        g.setColor(new Color(COLOR_AMARILLO));
                        g.fillArc(BORDE+(PIXELSCUADRADO+1)*j, BORDE+(PIXELSCUADRADO+1)*i, PIXELSCUADRADO-2, PIXELSCUADRADO-2, 30, 300);
                        break;
                    case Temporizador.ICONO_ENEMIGO_VERDE:
                        g.setColor(new Color(COLOR_VERDE));
                        // Figura
                        g.fillArc(BORDE+(PIXELSCUADRADO+1)*j, BORDE+(PIXELSCUADRADO+1)*i, PIXELSCUADRADO-2, PIXELSCUADRADO-2, 0, 180);
                        g.fillRect(BORDE+(PIXELSCUADRADO+1)*j, BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/2)-1, PIXELSCUADRADO, PIXELSCUADRADO/3);
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j, BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/2)+(PIXELSCUADRADO/6), PIXELSCUADRADO/3, PIXELSCUADRADO/3);
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j+(PIXELSCUADRADO/3), BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/2)+(PIXELSCUADRADO/6), PIXELSCUADRADO/3, PIXELSCUADRADO/3);
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j+(2*PIXELSCUADRADO/3), BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/2)+(PIXELSCUADRADO/6), PIXELSCUADRADO/3, PIXELSCUADRADO/3);
                        // Ojos
                        g.setColor(new Color(COLOR_BLANCO));
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j+(PIXELSCUADRADO/4), BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/4), PIXELSCUADRADO/5, PIXELSCUADRADO/4);
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j+(2*PIXELSCUADRADO/4), BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/4), PIXELSCUADRADO/5, PIXELSCUADRADO/4);
                        g.setColor(new Color(COLOR_NEGRO));
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j+(PIXELSCUADRADO/4)+PIXELSCUADRADO/20, BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/4)+PIXELSCUADRADO/8, PIXELSCUADRADO/10, PIXELSCUADRADO/8);
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j+(2*PIXELSCUADRADO/4)+PIXELSCUADRADO/20, BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/4)+PIXELSCUADRADO/8, PIXELSCUADRADO/10, PIXELSCUADRADO/8);
                        break;
                    case Temporizador.ICONO_ENEMIGO_AZUL:
                        g.setColor(new Color(COLOR_AZUL));
                        // Figura
                        g.fillArc(BORDE+(PIXELSCUADRADO+1)*j, BORDE+(PIXELSCUADRADO+1)*i, PIXELSCUADRADO-2, PIXELSCUADRADO-2, 0, 180);
                        g.fillRect(BORDE+(PIXELSCUADRADO+1)*j, BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/2)-1, PIXELSCUADRADO, PIXELSCUADRADO/3);
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j, BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/2)+(PIXELSCUADRADO/6), PIXELSCUADRADO/3, PIXELSCUADRADO/3);
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j+(PIXELSCUADRADO/3), BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/2)+(PIXELSCUADRADO/6), PIXELSCUADRADO/3, PIXELSCUADRADO/3);
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j+(2*PIXELSCUADRADO/3), BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/2)+(PIXELSCUADRADO/6), PIXELSCUADRADO/3, PIXELSCUADRADO/3);
                        // Ojos
                        g.setColor(new Color(COLOR_BLANCO));
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j+(PIXELSCUADRADO/4), BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/4), PIXELSCUADRADO/5, PIXELSCUADRADO/4);
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j+(2*PIXELSCUADRADO/4), BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/4), PIXELSCUADRADO/5, PIXELSCUADRADO/4);
                        g.setColor(new Color(COLOR_NEGRO));
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j+(PIXELSCUADRADO/4)+PIXELSCUADRADO/20, BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/4)+PIXELSCUADRADO/8, PIXELSCUADRADO/10, PIXELSCUADRADO/8);
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j+(2*PIXELSCUADRADO/4)+PIXELSCUADRADO/20, BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/4)+PIXELSCUADRADO/8, PIXELSCUADRADO/10, PIXELSCUADRADO/8);
                        break;
                    case Temporizador.ICONO_ENEMIGO_ROJO:
                        g.setColor(new Color(COLOR_ROJO));
                        // Figura
                        g.fillArc(BORDE+(PIXELSCUADRADO+1)*j, BORDE+(PIXELSCUADRADO+1)*i, PIXELSCUADRADO-2, PIXELSCUADRADO-2, 0, 180);
                        g.fillRect(BORDE+(PIXELSCUADRADO+1)*j, BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/2)-1, PIXELSCUADRADO, PIXELSCUADRADO/3);
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j, BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/2)+(PIXELSCUADRADO/6), PIXELSCUADRADO/3, PIXELSCUADRADO/3);
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j+(PIXELSCUADRADO/3), BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/2)+(PIXELSCUADRADO/6), PIXELSCUADRADO/3, PIXELSCUADRADO/3);
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j+(2*PIXELSCUADRADO/3), BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/2)+(PIXELSCUADRADO/6), PIXELSCUADRADO/3, PIXELSCUADRADO/3);
                        // Ojos
                        g.setColor(new Color(COLOR_BLANCO));
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j+(PIXELSCUADRADO/4), BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/4), PIXELSCUADRADO/5, PIXELSCUADRADO/4);
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j+(2*PIXELSCUADRADO/4), BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/4), PIXELSCUADRADO/5, PIXELSCUADRADO/4);
                        g.setColor(new Color(COLOR_NEGRO));
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j+(PIXELSCUADRADO/4)+PIXELSCUADRADO/20, BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/4)+PIXELSCUADRADO/8, PIXELSCUADRADO/10, PIXELSCUADRADO/8);
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j+(2*PIXELSCUADRADO/4)+PIXELSCUADRADO/20, BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/4)+PIXELSCUADRADO/8, PIXELSCUADRADO/10, PIXELSCUADRADO/8);
                        break;
                    case Temporizador.ICONO_ENEMIGO_CYAN:
                        g.setColor(new Color(COLOR_CYAN));
                        // Figura
                        g.fillArc(BORDE+(PIXELSCUADRADO+1)*j, BORDE+(PIXELSCUADRADO+1)*i, PIXELSCUADRADO-2, PIXELSCUADRADO-2, 0, 180);
                        g.fillRect(BORDE+(PIXELSCUADRADO+1)*j, BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/2)-1, PIXELSCUADRADO, PIXELSCUADRADO/3);
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j, BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/2)+(PIXELSCUADRADO/6), PIXELSCUADRADO/3, PIXELSCUADRADO/3);
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j+(PIXELSCUADRADO/3), BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/2)+(PIXELSCUADRADO/6), PIXELSCUADRADO/3, PIXELSCUADRADO/3);
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j+(2*PIXELSCUADRADO/3), BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/2)+(PIXELSCUADRADO/6), PIXELSCUADRADO/3, PIXELSCUADRADO/3);
                        // Ojos
                        g.setColor(new Color(COLOR_BLANCO));
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j+(PIXELSCUADRADO/4), BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/4), PIXELSCUADRADO/5, PIXELSCUADRADO/4);
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j+(2*PIXELSCUADRADO/4), BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/4), PIXELSCUADRADO/5, PIXELSCUADRADO/4);
                        g.setColor(new Color(COLOR_NEGRO));
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j+(PIXELSCUADRADO/4)+PIXELSCUADRADO/20, BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/4)+PIXELSCUADRADO/8, PIXELSCUADRADO/10, PIXELSCUADRADO/8);
                        g.fillOval(BORDE+(PIXELSCUADRADO+1)*j+(2*PIXELSCUADRADO/4)+PIXELSCUADRADO/20, BORDE+(PIXELSCUADRADO+1)*i+(PIXELSCUADRADO/4)+PIXELSCUADRADO/8, PIXELSCUADRADO/10, PIXELSCUADRADO/8);
                        break;

                }
            }
        }

        // Pinta los puntos
        g.setColor(Color.black);
        g.fillRect(BORDE + (PIXELSCUADRADO+1)* (ancho +1) - 5, BORDE+ (PIXELSCUADRADO+1)* (alto - 3) + 7,
                ANCHODERECHA - 2, PIXELSCUADRADO);
        g.setColor(Color.white);
        g.drawString("Puntos: " + tableroFisico.getPuntos(), BORDE+ (PIXELSCUADRADO+1)* (ancho +1) , BORDE+ (PIXELSCUADRADO+1)* (alto - 2));
    }

    // Clase interna que maneja la pulsación de teclas
    private class TeclaPulsada extends KeyAdapter {
        private Temporizador t;
        public TeclaPulsada(Temporizador t) {
            this.t = t;
        }

        public void keyPressed (KeyEvent e) {
            char key = e.getKeyChar();
            t.teclaPulsada(String.valueOf(key));
        }
    }
}


