package practicas;

/**
 * User: Manuel Pereira
 * Date: 05-may-2006
 * Time: 16:46:01
 * Esta clase deberá ser modificada por el alumno para realizar la práctica 3
 */

public class RellenarPorAlumno extends Temporizador {

    // Definicin de constantes para dimensiones del tablero y tiempo de espera
    //public static final int ANCHO = 19;
    //public static final int ALTO = 17;
    public static final int TIEMPODEESPERAENMILISEGUNDOS = 500;

    private static Tablero tablero;
    
    private static int pantalla=1;

    /**
     * Mtodo principal
     * @param args Argumentos de línea de comandos
     */
    public static void main(String [] args)
    {
        int roj = Enemigo.COLOR_ROJO;
        int azu = Enemigo.COLOR_AZUL;
        int nar = Enemigo.COLOR_NARANJA;
        int ros = Enemigo.COLOR_ROSA;
        
        
        // Crea los enemigos (son asignados a casillas de tipo Guarida)
        Enemigo[] e = new Enemigo[4];
        e[0] = new Enemigo(12, 12, Individuo.DIRECCION_ARRIBA, "Reud", roj);
        e[1] = new Enemigo(13, 12, Individuo.DIRECCION_ARRIBA, "Loki", azu);
        e[2] = new Enemigo(14, 12, Individuo.DIRECCION_ARRIBA, "Scio", nar);
        e[3] = new Enemigo(15, 12, Individuo.DIRECCION_ARRIBA, "Niel", ros);
        Lista enemigos = new Lista(e);
        
        // Crea el protagonista
        Protagonista prota = new Protagonista(13, 21, Individuo.DIRECCION_IZQUIERDA);

        // Crea el tablero
        tablero = new Tablero(enemigos, prota);
        
        // Inicializamos el tablero
        tablero.crearTableroInicial();
        
        // Mostramos el tablero
	    ComecocosPractica3 tet = new ComecocosPractica3(tablero.getAncho(), tablero.getAlto(),TIEMPODEESPERAENMILISEGUNDOS);
        tet.show();
		
    }

    /**
     * A este mtodo se le llama cada vez que pasa un tiempo determinado
     * por la variable TIEMPODEESPERAENMILISEGUNDOS
     * EL CDIGO QUE SE PROPORCIONA ES SLO UN EJEMPLO, YA QUE ESTE MTODO DEBER
     * SER ESCRITO POR COMPLETO POR EL ALUMNO PARA REALIZAR LAS CUESTIONES
     * QUE SE PLANTEAN EN LA PRCTICA 3
     */
    public void siguienteTiempo() {
        
        tablero.siguienteMovimiento();
        
        // Ejemplo que rellena cada cuadrado del tablero con un tipo de casilla aleatoria
        for(int i=0; i< tablero.getAlto(); i++) {
            for(int j=0; j<tablero.getAncho(); j++) {
                int tipoCasilla = obtenerTipoCasillaAleatoria();
                pintarCuadradoTablero(i, j, tipoCasilla);
            }
        }

        // Ejemplo que incrementa los puntos a un nmero aleatorio entre 0 y 100
        int p=(int)(Math.random() * 100000);
        tablero.setPuntos(p);

        // Ejemplo que establece el siguiente tiempo de espera
        establecerTiempoDeEspera(TIEMPODEESPERAENMILISEGUNDOS);
		

    }

    /**
     * Mtodo que es invocado cada vez que el usuario pulsa cualquier tecla
     * La implementacin que se proporciona slo responde a la tecla 'q', que
     * hace que finalice la ejecucin del programa
     * EL CDIGO QUE SE PROPORCIONA ES SLO UN EJEMPLO, YA QUE ESTE MTODO DEBER
     * SER ESCRITO POR COMPLETO POR EL ALUMNO PARA REALIZAR LAS CUESTIONES
     * QUE SE PLANTEAN EN LA PRCTICA 3
     * @param tecla La tecla pulsada
     */
    public void teclaPulsada(String tecla) {
        tablero.getProta().cambiaDireccion(tecla);
    }
    
    public Tablero getTablero(){
    	return tablero;
	}
	
	/**
     * Mtodo auxiliar de ejemplo para obtener un tipo de casilla aleatoria
     * @return El tipo de casilla aleatorio generado
     */
    private int obtenerTipoCasillaAleatoria() {
        int tipoCasilla = (int)(Math.random() * 13);
        switch(tipoCasilla) {
            case 1:
                return Temporizador.ICONO_VACIA;
            case 2:
                return Temporizador.ICONO_MURO;
            case 3:
                return Temporizador.ICONO_PUNTO;
            case 4:
                return Temporizador.ICONO_PROTAGONISTA_ARRIBA;
            case 5:
                return Temporizador.ICONO_PROTAGONISTA_ABAJO;
            case 6:
                return Temporizador.ICONO_PROTAGONISTA_IZQUIERDA;
            case 7:
                return Temporizador.ICONO_PROTAGONISTA_DERECHA;
            case 8:
                return Temporizador.ICONO_ENEMIGO_VERDE;
            case 9:
                return Temporizador.ICONO_ENEMIGO_AZUL;
            case 10:
                return Temporizador.ICONO_ENEMIGO_ROJO;
            case 11:
                return Temporizador.ICONO_ENEMIGO_CYAN;
            case 12:
                return Temporizador.ICONO_GUARIDA;
            case 13:
                return Temporizador.ICONO_FRUTA;
        }
        return tipoCasilla;
    }
}
