package practicas;

/**
 * User: Manuel Pereira
 * Date: 05-may-2006
 * Time: 16:46:01
 * Clase padre para evitar complejidad en la clase practicas.RellenarPorAlumno
 * Esta clase NO deberá ser modificada por el alumno para realizar la práctica 3
 */

public abstract class Temporizador extends Thread {

    // Definición de constantes para los diferentes tipos de icono a pintar
    public static final int ICONO_FRUTA = -2;
    public static final int ICONO_GUARIDA = -1;
    public static final int ICONO_VACIA = 0;
    public static final int ICONO_MURO = 1;
    public static final int ICONO_PUNTO = 2;
    public static final int ICONO_PROTAGONISTA_ARRIBA = 3;
    public static final int ICONO_PROTAGONISTA_ABAJO = 4;
    public static final int ICONO_PROTAGONISTA_IZQUIERDA = 5;
    public static final int ICONO_PROTAGONISTA_DERECHA = 6;
    public static final int ICONO_ENEMIGO_VERDE = 7;
    public static final int ICONO_ENEMIGO_AZUL = 8;
    public static final int ICONO_ENEMIGO_ROJO = 9;
    public static final int ICONO_ENEMIGO_CYAN = 10;

    // Referencia privada al comecocos
    public static ComecocosPractica3 comecocos;

    // Intervalo de tiempo entre pasos
    public static long intervalo;

    // Punto de entrada del thread
    public void run ()
    {
        while (true) {
            comecocos.repaint();
            yield();
            try {
                sleep(intervalo);
                siguienteTiempo();
            } catch(InterruptedException e) { }
        }
    }

    /**
     * Pinta un cuadrado del comecocos de un tipo determinado
     * @param x posición x, empezando en cero
     * @param y posición y, empezando en cero
     * @param tipoCasilla Tipo de la casilla de la que pintar el cuadrado.
     *      Los posibles tipos de casilla se definen como las siguientes constantes:
     *          Temporizador.ICONO_VACIA
     *          Temporizador.ICONO_MURO
     *          Temporizador.ICONO_PUNTO
     *          Temporizador.ICONO_PROTAGONISTA_ARRIBA
     *          Temporizador.ICONO_PROTAGONISTA_ABAJO
     *          Temporizador.ICONO_PROTAGONISTA_IZQUIERDA
     *          Temporizador.ICONO_PROTAGONISTA_DERECHA
     *          Temporizador.ICONO_ENEMIGO_VERDE
     *          Temporizador.ICONO_ENEMIGO_AZUL
     *          Temporizador.ICONO_ENEMIGO_ROJO
     *          Temporizador.ICONO_ENEMIGO_CYAN
     */

    public void pintarCuadradoTablero(int x, int y, int tipoCasilla) {
         comecocos.tablero[x][y] = tipoCasilla;
    }

    /**
     * Establece la puntuación actual
     * @param puntos la puntuación
     */
    public void establecerPuntos(int puntos) {
        comecocos.puntos = puntos;
    }

    /**
     * Devuelve la puntuación actual
     * @return puntos la puntuación
     */
    public int obtenerPuntos() {
        return comecocos.puntos;
    }

    /**
     * Establece el tiempo de espera entre paso y paso
     * @param tiempo tiempo en milisegundos
     */
    public void establecerTiempoDeEspera(long tiempo) {
        Temporizador.intervalo = tiempo;
    }

    /**
     * Método invocado cada vez que transcurre el tiempo de espera
     */
    public abstract void siguienteTiempo();

    /**
     * Método invocado cada vez que el usuario pulsa una tecla
     * @param tecla la tecla pulsada
     */
    public abstract void teclaPulsada(String tecla);
}
